//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package license helps manage commercial licenses and check if they are valid for the version of unidoc used.
package license ;import (_d "crypto";_g "crypto/rand";_aa "crypto/rsa";_gf "crypto/sha512";_ag "crypto/x509";_dg "encoding/base64";_ad "encoding/json";_ae "encoding/pem";_a "fmt";_ga "github.com/unidoc/unipdf/v3/common";_e "io/ioutil";_c "os";_da "strings";_ff "time";);

// LicenseKey represents a loaded license key.
type LicenseKey struct{LicenseId string `json:"license_id"`;CustomerId string `json:"customer_id"`;CustomerName string `json:"customer_name"`;Tier string `json:"tier"`;CreatedAt _ff .Time `json:"-"`;CreatedAtInt int64 `json:"created_at"`;ExpiresAt *_ff .Time `json:"-"`;ExpiresAtInt int64 `json:"expires_at"`;CreatedBy string `json:"created_by"`;CreatorName string `json:"creator_name"`;CreatorEmail string `json:"creator_email"`;UniPDF bool `json:"unipdf"`;UniOffice bool `json:"unioffice"`;Trial bool `json:"trial"`;};var _fc =_ff .Date (2010,1,1,0,0,0,0,_ff .UTC );

// IsLicensed returns true if the k is licensed.
func (_ced *LicenseKey )IsLicensed ()bool {return _ced .Tier !=LicenseTierUnlicensed };

// MakeUnlicensedKey returns a default key.
func MakeUnlicensedKey ()*LicenseKey {_ed :=LicenseKey {};_ed .CustomerName ="\u0055\u006e\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u0064";_ed .Tier =LicenseTierUnlicensed ;_ed .CreatedAt =_ff .Now ().UTC ();_ed .CreatedAtInt =_ed .CreatedAt .Unix ();return &_ed ;};func _gfa (_ea string )(LicenseKey ,error ){var _cfa LicenseKey ;_dgb ,_cee :=_fge (_gd ,_gfb ,_ea );if _cee !=nil {return _cfa ,_cee ;};_ec ,_cee :=_fg (_eee ,_dgb );if _cee !=nil {return _cfa ,_cee ;};_cee =_ad .Unmarshal (_ec ,&_cfa );if _cee !=nil {return _cfa ,_cee ;};_cfa .CreatedAt =_ff .Unix (_cfa .CreatedAtInt ,0);if _cfa .ExpiresAtInt > 0{_gfc :=_ff .Unix (_cfa .ExpiresAtInt ,0);_cfa .ExpiresAt =&_gfc ;};return _cfa ,nil ;};var _fe =_ff .Date (2019,6,6,0,0,0,0,_ff .UTC );func (_dab *LicenseKey )getExpiryDateToCompare ()_ff .Time {if _dab .Trial {return _ff .Now ().UTC ();};return _ga .ReleasedAt ;};func _fge (_gbb string ,_gc string ,_deg string )(string ,error ){_ab :=_da .Index (_deg ,_gbb );if _ab ==-1{return "",_a .Errorf ("\u0068\u0065a\u0064\u0065\u0072 \u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};_fa :=_da .Index (_deg ,_gc );if _fa ==-1{return "",_a .Errorf ("\u0066\u006fo\u0074\u0065\u0072 \u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};_gea :=_ab +len (_gbb )+1;return _deg [_gea :_fa -1],nil ;};const (LicenseTierUnlicensed ="\u0075\u006e\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u0064";LicenseTierCommunity ="\u0063o\u006d\u006d\u0075\u006e\u0069\u0074y";LicenseTierIndividual ="\u0069\u006e\u0064\u0069\u0076\u0069\u0064\u0075\u0061\u006c";LicenseTierBusiness ="\u0062\u0075\u0073\u0069\u006e\u0065\u0073\u0073";);var _dd =MakeUnlicensedKey ();

// ToString returns a string summary of the license key.
func (_gff *LicenseKey )ToString ()string {_dba :=_a .Sprintf ("\u004ci\u0063e\u006e\u0073\u0065\u0020\u0049\u0064\u003a\u0020\u0025\u0073\u000a",_gff .LicenseId );_dba +=_a .Sprintf ("\u0043\u0075s\u0074\u006f\u006de\u0072\u0020\u0049\u0064\u003a\u0020\u0025\u0073\u000a",_gff .CustomerId );_dba +=_a .Sprintf ("\u0043u\u0073t\u006f\u006d\u0065\u0072\u0020N\u0061\u006de\u003a\u0020\u0025\u0073\u000a",_gff .CustomerName );_dba +=_a .Sprintf ("\u0054i\u0065\u0072\u003a\u0020\u0025\u0073\n",_gff .Tier );_dba +=_a .Sprintf ("\u0043r\u0065a\u0074\u0065\u0064\u0020\u0041\u0074\u003a\u0020\u0025\u0073\u000a",_ga .UtcTimeFormat (_gff .CreatedAt ));if _gff .ExpiresAt ==nil {_dba +="\u0045x\u0070i\u0072\u0065\u0073\u0020\u0041t\u003a\u0020N\u0065\u0076\u0065\u0072\u000a";}else {_dba +=_a .Sprintf ("\u0045x\u0070i\u0072\u0065\u0073\u0020\u0041\u0074\u003a\u0020\u0025\u0073\u000a",_ga .UtcTimeFormat (*_gff .ExpiresAt ));};_dba +=_a .Sprintf ("\u0043\u0072\u0065\u0061\u0074\u006f\u0072\u003a\u0020\u0025\u0073\u0020<\u0025\u0073\u003e\u000a",_gff .CreatorName ,_gff .CreatorEmail );return _dba ;};func _cg (_de string ,_b []byte )(string ,error ){_ce ,_ :=_ae .Decode ([]byte (_de ));if _ce ==nil {return "",_a .Errorf ("\u0050\u0072\u0069\u0076\u004b\u0065\u0079\u0020\u0066a\u0069\u006c\u0065\u0064");};_ceb ,_gfg :=_ag .ParsePKCS1PrivateKey (_ce .Bytes );if _gfg !=nil {return "",_gfg ;};_ba :=_gf .New ();_ba .Write (_b );_gg :=_ba .Sum (nil );_ac ,_gfg :=_aa .SignPKCS1v15 (_g .Reader ,_ceb ,_d .SHA512 ,_gg );if _gfg !=nil {return "",_gfg ;};_dee :=_dg .StdEncoding .EncodeToString (_b );_dee +="\u000a\u002b\u000a";_dee +=_dg .StdEncoding .EncodeToString (_ac );return _dee ,nil ;};

// SetLicenseKey sets and validates the license key.
func SetLicenseKey (content string ,customerName string )error {_fab ,_fbce :=_gfa (content );if _fbce !=nil {_ga .Log .Error ("\u004c\u0069c\u0065\u006e\u0073\u0065\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0063\u006f\u0064\u0065\u0020\u0065\u0072\u0072\u006f\u0072: \u0025\u0076",_fbce );return _fbce ;};if !_da .EqualFold (_fab .CustomerName ,customerName ){_ga .Log .Error ("L\u0069ce\u006es\u0065 \u0063\u006f\u0064\u0065\u0020i\u0073\u0073\u0075e\u0020\u002d\u0020\u0043\u0075s\u0074\u006f\u006de\u0072\u0020\u006e\u0061\u006d\u0065\u0020\u006d\u0069\u0073\u006da\u0074\u0063\u0068, e\u0078\u0070\u0065\u0063\u0074\u0065d\u0020\u0027\u0025\u0073\u0027\u002c\u0020\u0062\u0075\u0074\u0020\u0067o\u0074 \u0027\u0025\u0073\u0027",customerName ,_fab .CustomerName );return _a .Errorf ("\u0063\u0075\u0073\u0074\u006fm\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0020\u006d\u0069\u0073\u006d\u0061t\u0063\u0068\u002c\u0020\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0025\u0073\u0027\u002c\u0020\u0062\u0075\u0074\u0020\u0067\u006f\u0074\u0020\u0027\u0025\u0073'",customerName ,_fab .CustomerName );};_fbce =_fab .Validate ();if _fbce !=nil {_ga .Log .Error ("\u004c\u0069\u0063\u0065\u006e\u0073e\u0020\u0063\u006f\u0064\u0065\u0020\u0076\u0061\u006c\u0069\u0064\u0061\u0074i\u006f\u006e\u0020\u0065\u0072\u0072\u006fr\u003a\u0020\u0025\u0076",_fbce );return _fbce ;};_dd =&_fab ;return nil ;};const _dc ="\u0055\u004e\u0049\u0050DF\u005f\u004c\u0049\u0043\u0045\u004e\u0053\u0045\u005f\u0050\u0041\u0054\u0048";const (_gd ="\u002d\u002d\u002d--\u0042\u0045\u0047\u0049\u004e\u0020\u0055\u004e\u0049D\u004fC\u0020L\u0049C\u0045\u004e\u0053\u0045\u0020\u004b\u0045\u0059\u002d\u002d\u002d\u002d\u002d";_gfb ="\u002d\u002d\u002d\u002d\u002d\u0045\u004e\u0044\u0020\u0055\u004e\u0049\u0044\u004f\u0043 \u004cI\u0043\u0045\u004e\u0053\u0045\u0020\u004b\u0045\u0059\u002d\u002d\u002d\u002d\u002d";);const _ddd ="U\u004eI\u0050\u0044\u0046\u005f\u0043\u0055\u0053\u0054O\u004d\u0045\u0052\u005fNA\u004d\u0045";func (_fce *LicenseKey )isExpired ()bool {return _fce .getExpiryDateToCompare ().After (*_fce .ExpiresAt )};

// TypeToString returns a readable string representing the license key type.
func (_ffb *LicenseKey )TypeToString ()string {if _ffb .Tier ==LicenseTierUnlicensed {return "\u0055\u006e\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u0064";};if _ffb .Tier ==LicenseTierCommunity {return "\u0041\u0047PL\u0076\u0033\u0020O\u0070\u0065\u006e\u0020Sou\u0072ce\u0020\u0043\u006f\u006d\u006d\u0075\u006eit\u0079\u0020\u004c\u0069\u0063\u0065\u006es\u0065";};if _ffb .Tier ==LicenseTierIndividual ||_ffb .Tier =="\u0069\u006e\u0064i\u0065"{return "\u0043\u006f\u006dm\u0065\u0072\u0063\u0069a\u006c\u0020\u004c\u0069\u0063\u0065\u006es\u0065\u0020\u002d\u0020\u0049\u006e\u0064\u0069\u0076\u0069\u0064\u0075\u0061\u006c";};return "\u0043\u006fm\u006d\u0065\u0072\u0063\u0069\u0061\u006c\u0020\u004c\u0069\u0063\u0065\u006e\u0073\u0065\u0020\u002d\u0020\u0042\u0075\u0073\u0069ne\u0073\u0073";};const _eee ="\u000a\u002d\u002d\u002d\u002d\u002d\u0042\u0045\u0047\u0049\u004e \u0050\u0055\u0042\u004c\u0049\u0043\u0020\u004b\u0045Y\u002d\u002d\u002d\u002d\u002d\u000a\u004d\u0049I\u0042\u0049\u006a\u0041NB\u0067\u006b\u0071\u0068\u006b\u0069G\u0039\u0077\u0030\u0042\u0041\u0051\u0045\u0046A\u0041\u004f\u0043\u0041\u0051\u0038\u0041\u004d\u0049\u0049\u0042\u0043\u0067\u004b\u0043\u0041\u0051\u0045A\u006dF\u0055\u0069\u0079\u0064\u0037\u0062\u0035\u0058\u006a\u0070\u006b\u0050\u0035\u0052\u0061\u0070\u0034\u0077\u000a\u0044\u0063\u0031d\u0079\u007a\u0049\u0051\u0034\u004c\u0065\u006b\u0078\u0072\u0076\u0079\u0074\u006e\u0045\u004d\u0070\u004e\u0055\u0062\u006f\u0036i\u0041\u0037\u0034\u0056\u0038\u0072\u0075\u005a\u004f\u0076\u0072\u0053\u0063\u0073\u0066\u0032\u0051\u0065\u004e9\u002f\u0071r\u0055\u0047\u0038\u0071\u0045\u0062\u0055\u0057\u0064\u006f\u0045\u0059\u0071+\u000a\u006f\u0074\u0046\u004e\u0041\u0046N\u0078\u006c\u0047\u0062\u0078\u0062\u0044\u0048\u0063\u0064\u0047\u0056\u0061\u004d\u0030\u004f\u0058\u0064\u0058g\u0044y\u004c5\u0061\u0049\u0045\u0061\u0067\u004c\u0030\u0063\u0035\u0070\u0077\u006a\u0049\u0064\u0050G\u0049\u006e\u0034\u0036\u0066\u0037\u0038\u0065\u004d\u004a\u002b\u004a\u006b\u0064\u0063\u0070\u0044\n\u0044\u004a\u0061\u0071\u0059\u0058d\u0072\u007a5\u004b\u0065\u0073\u0068\u006aS\u0069\u0049\u0061\u0061\u0037\u006d\u0065\u006e\u0042\u0049\u0041\u0058\u0053\u0034\u0055\u0046\u0078N\u0066H\u0068\u004e\u0030\u0048\u0043\u0059\u005a\u0059\u0071\u0051\u0047\u0037\u0062K+\u0073\u0035\u0072R\u0048\u006f\u006e\u0079\u0064\u004eW\u0045\u0047\u000a\u0048\u0038M\u0079\u0076\u00722\u0070\u0079\u0061\u0032K\u0072\u004d\u0075m\u0066\u006d\u0041\u0078\u0055\u0042\u0036\u0066\u0065\u006e\u0043\u002f4\u004f\u0030\u0057\u00728\u0067\u0066\u0050\u004f\u0055\u0038R\u0069\u0074\u006d\u0062\u0044\u0076\u0051\u0050\u0049\u0052\u0058\u004fL\u0034\u0076\u0054B\u0072\u0042\u0064\u0062a\u0041\u000a9\u006e\u0077\u004e\u0050\u002b\u0069\u002f\u002f\u0032\u0030\u004d\u00542\u0062\u0078\u006d\u0065\u0057\u0042\u002b\u0067\u0070\u0063\u0045\u0068G\u0070\u0058\u005a7\u0033\u0033\u0061\u007a\u0051\u0078\u0072\u0043\u0033\u004a\u0034\u0076\u0033C\u005a\u006d\u0045\u004eS\u0074\u0044\u004b\u002f\u004b\u0044\u0053\u0050\u004b\u0055\u0047\u0066\u00756\u000a\u0066\u0077I\u0044\u0041\u0051\u0041\u0042\u000a\u002d\u002d\u002d\u002d\u002dE\u004e\u0044\u0020\u0050\u0055\u0042\u004c\u0049\u0043 \u004b\u0045Y\u002d\u002d\u002d\u002d\u002d\n";

// Validate returns nil if the license key is valid, otherwise an error is returned.
func (_bab *LicenseKey )Validate ()error {if len (_bab .LicenseId )< 10{return _a .Errorf ("i\u006e\u0076\u0061\u006c\u0069\u0064 \u006c\u0069\u0063\u0065\u006e\u0073\u0065\u003a\u0020L\u0069\u0063\u0065n\u0073e\u0020\u0049\u0064");};if len (_bab .CustomerId )< 10{return _a .Errorf ("\u0069\u006e\u0076\u0061l\u0069\u0064\u0020\u006c\u0069\u0063\u0065\u006e\u0073\u0065:\u0020C\u0075\u0073\u0074\u006f\u006d\u0065\u0072 \u0049\u0064");};if len (_bab .CustomerName )< 1{return _a .Errorf ("\u0069\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u006c\u0069c\u0065\u006e\u0073\u0065\u003a\u0020\u0043u\u0073\u0074\u006f\u006d\u0065\u0072\u0020\u004e\u0061\u006d\u0065");};if _fc .After (_bab .CreatedAt ){return _a .Errorf ("\u0069\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u003a\u0020\u0043\u0072\u0065\u0061\u0074\u0065\u0064 \u0041\u0074\u0020\u0069\u0073 \u0069\u006ev\u0061\u006c\u0069\u0064");};if _bab .ExpiresAt ==nil {_cd :=_bab .CreatedAt .AddDate (1,0,0);if _bb .After (_cd ){_cd =_bb ;};_bab .ExpiresAt =&_cd ;};if _bab .CreatedAt .After (*_bab .ExpiresAt ){return _a .Errorf ("i\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u003a\u0020\u0043\u0072\u0065\u0061\u0074\u0065\u0064\u0020\u0041\u0074 \u0063a\u006e\u006e\u006f\u0074 \u0062\u0065 \u0047\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0045\u0078\u0070\u0069\u0072\u0065\u0073\u0020\u0041\u0074");};if _bab .isExpired (){return _a .Errorf ("\u0069\u006e\u0076\u0061\u006c\u0069\u0064\u0020l\u0069\u0063\u0065ns\u0065\u003a\u0020\u0054\u0068\u0065 \u006c\u0069\u0063\u0065\u006e\u0073\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u006c\u0072e\u0061\u0064\u0079\u0020\u0065\u0078\u0070\u0069r\u0065\u0064");};if len (_bab .CreatorName )< 1{return _a .Errorf ("\u0069\u006ev\u0061\u006c\u0069\u0064\u0020\u006c\u0069\u0063\u0065\u006e\u0073\u0065\u003a\u0020\u0043\u0072\u0065\u0061\u0074\u006f\u0072\u0020na\u006d\u0065");};if len (_bab .CreatorEmail )< 1{return _a .Errorf ("\u0069\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u006c\u0069c\u0065\u006e\u0073\u0065\u003a\u0020\u0043r\u0065\u0061\u0074\u006f\u0072\u0020\u0065\u006d\u0061\u0069\u006c");};if _bab .CreatedAt .After (_fe ){if !_bab .UniPDF {return _a .Errorf ("\u0069\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u006c\u0069\u0063\u0065\u006e\u0073\u0065:\u0020\u0054\u0068\u0069\u0073\u0020\u0055\u006e\u0069\u0044\u006f\u0063\u0020k\u0065\u0079\u0020\u0069\u0073\u0020\u0069\u006e\u0076\u0061\u006c\u0069d \u0066\u006f\u0072\u0020\u0055\u006e\u0069\u0050\u0044\u0046");};};return nil ;};func _fg (_fb string ,_ggd string )([]byte ,error ){_db :="\u000a\u002b\u000a";_bd :="\u000d\u000a\u002b\r\u000a";_dgf :=_da .Index (_ggd ,_db );if _dgf ==-1{_dgf =_da .Index (_ggd ,_bd );if _dgf ==-1{return nil ,_a .Errorf ("\u0069\u006e\u0076al\u0069\u0064\u0020\u0069\u006e\u0070\u0075\u0074\u002c \u0073i\u0067n\u0061t\u0075\u0072\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u006f\u0072");};};_aec :=_ggd [:_dgf ];_fbc :=_dgf +len (_db );_df :=_ggd [_fbc :];if _aec ==""||_df ==""{return nil ,_a .Errorf ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0069n\u0070\u0075\u0074,\u0020\u006d\u0069\u0073\u0073\u0069\u006e\u0067\u0020or\u0069\u0067\u0069n\u0061\u006c \u006f\u0072\u0020\u0073\u0069\u0067n\u0061\u0074u\u0072\u0065");};_dbd ,_gdbe :=_dg .StdEncoding .DecodeString (_aec );if _gdbe !=nil {return nil ,_a .Errorf ("\u0069\u006e\u0076\u0061li\u0064\u0020\u0069\u006e\u0070\u0075\u0074\u0020\u006f\u0072\u0069\u0067\u0069\u006ea\u006c");};_ee ,_gdbe :=_dg .StdEncoding .DecodeString (_df );if _gdbe !=nil {return nil ,_a .Errorf ("\u0069\u006e\u0076al\u0069\u0064\u0020\u0069\u006e\u0070\u0075\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_gb ,_ :=_ae .Decode ([]byte (_fb ));if _gb ==nil {return nil ,_a .Errorf ("\u0050\u0075\u0062\u004b\u0065\u0079\u0020\u0066\u0061\u0069\u006c\u0065\u0064");};_cgf ,_gdbe :=_ag .ParsePKIXPublicKey (_gb .Bytes );if _gdbe !=nil {return nil ,_gdbe ;};_ge :=_cgf .(*_aa .PublicKey );if _ge ==nil {return nil ,_a .Errorf ("\u0050u\u0062\u004b\u0065\u0079\u0020\u0063\u006f\u006e\u0076\u0065\u0072s\u0069\u006f\u006e\u0020\u0066\u0061\u0069\u006c\u0065\u0064");};_cf :=_gf .New ();_cf .Write (_dbd );_gdg :=_cf .Sum (nil );_gdbe =_aa .VerifyPKCS1v15 (_ge ,_d .SHA512 ,_gdg ,_ee );if _gdbe !=nil {return nil ,_gdbe ;};return _dbd ,nil ;};func GetLicenseKey ()*LicenseKey {if _dd ==nil {return nil ;};_faf :=*_dd ;return &_faf ;};func init (){_babg :=_c .Getenv (_dc );_dec :=_c .Getenv (_ddd );if len (_babg )==0||len (_dec )==0{return ;};_cb ,_dga :=_e .ReadFile (_babg );if _dga !=nil {_ga .Log .Error ("\u0055\u006eab\u006c\u0065\u0020t\u006f\u0020\u0072\u0065ad \u006cic\u0065\u006e\u0073\u0065\u0020\u0063\u006fde\u0020\u0066\u0069\u006c\u0065\u003a\u0020%\u0076",_dga );return ;};_dga =SetLicenseKey (string (_cb ),_dec );if _dga !=nil {_ga .Log .Error ("\u0055\u006e\u0061b\u006c\u0065\u0020\u0074o\u0020\u006c\u006f\u0061\u0064\u0020\u006ci\u0063\u0065\u006e\u0073\u0065\u0020\u0063\u006f\u0064\u0065\u003a\u0020\u0025\u0076",_dga );return ;};};var _bb =_ff .Date (2020,1,1,0,0,0,0,_ff .UTC );