//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_e "bufio";_bb "bytes";_dc "encoding/hex";_a "errors";_d "fmt";_af "github.com/unidoc/unipdf/v3/common";_f "github.com/unidoc/unipdf/v3/core";_db "io";_bd "os";_b "regexp";_abc "sort";_ab "strconv";_cg "strings";);func (_aee *fdfParser )parseHexString ()(*_f .PdfObjectString ,error ){_aee ._bge .ReadByte ();var _agb _bb .Buffer ;for {_ebce ,_ccec :=_aee ._bge .Peek (1);if _ccec !=nil {return _f .MakeHexString (""),_ccec ;};if _ebce [0]=='>'{_aee ._bge .ReadByte ();break ;};_egd ,_ :=_aee ._bge .ReadByte ();if !_f .IsWhiteSpace (_egd ){_agb .WriteByte (_egd );};};if _agb .Len ()%2==1{_agb .WriteRune ('0');};_bdbc ,_bdg :=_dc .DecodeString (_agb .String ());if _bdg !=nil {_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_agb .String ());return _f .MakeHexString (""),nil ;};return _f .MakeHexString (string (_bdbc )),nil ;};func (_fa *fdfParser )skipComments ()error {if _ ,_dgb :=_fa .skipSpaces ();_dgb !=nil {return _dgb ;};_bda :=true ;for {_cdf ,_egc :=_fa ._bge .Peek (1);if _egc !=nil {_af .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_egc .Error ());return _egc ;};if _bda &&_cdf [0]!='%'{return nil ;};_bda =false ;if (_cdf [0]!='\r')&&(_cdf [0]!='\n'){_fa ._bge .ReadByte ();}else {break ;};};return _fa .skipComments ();};

// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_f .PdfObjectDictionary ,error ){_eb :=map[string ]*_f .PdfObjectDictionary {};for _gga :=0;_gga < fdf ._ae .Len ();_gga ++{_abd ,_bf :=_f .GetDict (fdf ._ae .Get (_gga ));if _bf {_bg ,_ :=_f .GetString (_abd .Get ("\u0054"));if _bg !=nil {_eb [_bg .Str ()]=_abd ;};};};return _eb ,nil ;};func (_efc *fdfParser )parseName ()(_f .PdfObjectName ,error ){var _cc _bb .Buffer ;_ddf :=false ;for {_egf ,_cce :=_efc ._bge .Peek (1);if _cce ==_db .EOF {break ;};if _cce !=nil {return _f .PdfObjectName (_cc .String ()),_cce ;};if !_ddf {if _egf [0]=='/'{_ddf =true ;_efc ._bge .ReadByte ();}else if _egf [0]=='%'{_efc .readComment ();_efc .skipSpaces ();}else {_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_egf ,_egf );return _f .PdfObjectName (_cc .String ()),_d .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_egf [0]);};}else {if _f .IsWhiteSpace (_egf [0]){break ;}else if (_egf [0]=='/')||(_egf [0]=='[')||(_egf [0]=='(')||(_egf [0]==']')||(_egf [0]=='<')||(_egf [0]=='>'){break ;}else if _egf [0]=='#'{_cdfc ,_aef :=_efc ._bge .Peek (3);if _aef !=nil {return _f .PdfObjectName (_cc .String ()),_aef ;};_efc ._bge .Discard (3);_ad ,_aef :=_dc .DecodeString (string (_cdfc [1:3]));if _aef !=nil {return _f .PdfObjectName (_cc .String ()),_aef ;};_cc .Write (_ad );}else {_ccg ,_ :=_efc ._bge .ReadByte ();_cc .WriteByte (_ccg );};};};return _f .PdfObjectName (_cc .String ()),nil ;};func _gaf (_gbeb string )(*fdfParser ,error ){_eeg :=fdfParser {};_eaa :=[]byte (_gbeb );_baa :=_bb .NewReader (_eaa );_eeg ._ba =_baa ;_eeg ._dba =map[int64 ]_f .PdfObject {};_gac :=_e .NewReader (_baa );_eeg ._bge =_gac ;_eeg ._ca =int64 (len (_gbeb ));return &_eeg ,_eeg .parse ();};

// Root returns the Root of the FDF document.
func (_ecc *fdfParser )Root ()(*_f .PdfObjectDictionary ,error ){if _ecc ._dg !=nil {if _dgaa ,_eeac :=_ecc .trace (_ecc ._dg .Get ("\u0052\u006f\u006f\u0074")).(*_f .PdfObjectDictionary );_eeac {if _gag ,_cbgb :=_ecc .trace (_dgaa .Get ("\u0046\u0044\u0046")).(*_f .PdfObjectDictionary );_cbgb {return _gag ,nil ;};};};var _cgg []int64 ;for _gbf :=range _ecc ._dba {_cgg =append (_cgg ,_gbf );};_abc .Slice (_cgg ,func (_cad ,_cgaa int )bool {return _cgg [_cad ]< _cgg [_cgaa ]});for _ ,_gef :=range _cgg {_ecca :=_ecc ._dba [_gef ];if _bbe ,_ged :=_ecc .trace (_ecca ).(*_f .PdfObjectDictionary );_ged {if _dbf ,_fffc :=_ecc .trace (_bbe .Get ("\u0046\u0044\u0046")).(*_f .PdfObjectDictionary );_fffc {return _dbf ,nil ;};};};return nil ,_a .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func _ddca (_egfb _db .ReadSeeker )(*fdfParser ,error ){_cfbg :=&fdfParser {};_cfbg ._ba =_egfb ;_cfbg ._dba =map[int64 ]_f .PdfObject {};_bbea ,_cbgg ,_edd :=_cfbg .parseFdfVersion ();if _edd !=nil {_af .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_edd );return nil ,_edd ;};_cfbg ._acf =_bbea ;_cfbg ._eeb =_cbgg ;_edd =_cfbg .parse ();return _cfbg ,_edd ;};func _dgbg (_dbc string )(_f .PdfObjectReference ,error ){_bfg :=_f .PdfObjectReference {};_gccg :=_gge .FindStringSubmatch (_dbc );if len (_gccg )< 3{_af .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");return _bfg ,_a .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");};_aec ,_dcd :=_ab .Atoi (_gccg [1]);if _dcd !=nil {_af .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_gccg [1]);return _bfg ,nil ;};_bfg .ObjectNumber =int64 (_aec );_ge ,_dcd :=_ab .Atoi (_gccg [2]);if _dcd !=nil {_af .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_gccg [2]);return _bfg ,nil ;};_bfg .GenerationNumber =int64 (_ge );return _bfg ,nil ;};var _abb =_b .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");var _ac =_b .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");func (_ebf *fdfParser )getFileOffset ()int64 {_ag ,_ :=_ebf ._ba .Seek (0,_db .SeekCurrent );_ag -=int64 (_ebf ._bge .Buffered ());return _ag ;};var _gge =_b .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");func (_ddfg *fdfParser )seekToEOFMarker (_fff int64 )error {_eac :=int64 (0);_bdf :=int64 (1000);for _eac < _fff {if _fff <=(_bdf +_eac ){_bdf =_fff -_eac ;};_ ,_bgc :=_ddfg ._ba .Seek (-_eac -_bdf ,_db .SeekEnd );if _bgc !=nil {return _bgc ;};_bbc :=make ([]byte ,_bdf );_ddfg ._ba .Read (_bbc );_af .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_bbc ));_gdc :=_efd .FindAllStringIndex (string (_bbc ),-1);if _gdc !=nil {_bfa :=_gdc [len (_gdc )-1];_af .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_gdc );_ddfg ._ba .Seek (-_eac -_bdf +int64 (_bfa [0]),_db .SeekEnd );return nil ;};_af .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");_eac +=_bdf ;};_af .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _a .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func (_cgd *fdfParser )skipSpaces ()(int ,error ){_ff :=0;for {_fga ,_fgb :=_cgd ._bge .ReadByte ();if _fgb !=nil {return 0,_fgb ;};if _f .IsWhiteSpace (_fga ){_ff ++;}else {_cgd ._bge .UnreadByte ();break ;};};return _ff ,nil ;};func (_cfe *fdfParser )parseBool ()(_f .PdfObjectBool ,error ){_aff ,_fdc :=_cfe ._bge .Peek (4);if _fdc !=nil {return _f .PdfObjectBool (false ),_fdc ;};if (len (_aff )>=4)&&(string (_aff [:4])=="\u0074\u0072\u0075\u0065"){_cfe ._bge .Discard (4);return _f .PdfObjectBool (true ),nil ;};_aff ,_fdc =_cfe ._bge .Peek (5);if _fdc !=nil {return _f .PdfObjectBool (false ),_fdc ;};if (len (_aff )>=5)&&(string (_aff [:5])=="\u0066\u0061\u006cs\u0065"){_cfe ._bge .Discard (5);return _f .PdfObjectBool (false ),nil ;};return _f .PdfObjectBool (false ),_a .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func (_aae *fdfParser )parse ()error {_aae ._ba .Seek (0,_db .SeekStart );_aae ._bge =_e .NewReader (_aae ._ba );for {_aae .skipComments ();_aade ,_bae :=_aae ._bge .Peek (20);if _bae !=nil {_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");return _bae ;};if _cg .HasPrefix (string (_aade ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_aae ._bge .Discard (7);_aae .skipSpaces ();_aae .skipComments ();_gfgf ,_ :=_aae .parseDict ();_aae ._dg =_gfgf ;break ;};_cae :=_abb .FindStringSubmatchIndex (string (_aade ));if len (_cae )< 6{_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_aade ));return _a .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_baba ,_bae :=_aae .parseIndirectObject ();if _bae !=nil {return _bae ;};switch _fbf :=_baba .(type ){case *_f .PdfIndirectObject :_aae ._dba [_fbf .ObjectNumber ]=_fbf ;case *_f .PdfObjectStream :_aae ._dba [_fbf .ObjectNumber ]=_fbf ;default:return _a .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");};};return nil ;};func (_cab *fdfParser )trace (_beg _f .PdfObject )_f .PdfObject {switch _eed :=_beg .(type ){case *_f .PdfObjectReference :_cbd ,_gde :=_cab ._dba [_eed .ObjectNumber ].(*_f .PdfIndirectObject );if _gde {return _cbd .PdfObject ;};_af .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_f .PdfIndirectObject :return _eed .PdfObject ;};return _beg ;};func (_ggg *fdfParser )parseNumber ()(_f .PdfObject ,error ){return _f .ParseNumber (_ggg ._bge )};func (_ddb *fdfParser )parseFdfVersion ()(int ,int ,error ){_ddb ._ba .Seek (0,_db .SeekStart );_gfg :=20;_eae :=make ([]byte ,_gfg );_ddb ._ba .Read (_eae );_ceb :=_ac .FindStringSubmatch (string (_eae ));if len (_ceb )< 3{_dbb ,_ecg ,_df :=_ddb .seekFdfVersionTopDown ();if _df !=nil {_af .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");return 0,0,_df ;};return _dbb ,_ecg ,nil ;};_fbb ,_ffc :=_ab .Atoi (_ceb [1]);if _ffc !=nil {return 0,0,_ffc ;};_egebc ,_ffc :=_ab .Atoi (_ceb [2]);if _ffc !=nil {return 0,0,_ffc ;};_af .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_fbb ,_egebc );return _fbb ,_egebc ,nil ;};func (_egeb *fdfParser )parseDict ()(*_f .PdfObjectDictionary ,error ){_af .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");_ddff :=_f .MakeDict ();_acff ,_ :=_egeb ._bge .ReadByte ();if _acff !='<'{return nil ,_a .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_acff ,_ =_egeb ._bge .ReadByte ();if _acff !='<'{return nil ,_a .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};for {_egeb .skipSpaces ();_egeb .skipComments ();_egebe ,_efbf :=_egeb ._bge .Peek (2);if _efbf !=nil {return nil ,_efbf ;};_af .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_egebe ),string (_egebe ));if (_egebe [0]=='>')&&(_egebe [1]=='>'){_af .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_egeb ._bge .ReadByte ();_egeb ._bge .ReadByte ();break ;};_af .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");_adf ,_efbf :=_egeb .parseName ();_af .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_adf );if _efbf !=nil {_af .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_efbf );return nil ,_efbf ;};if len (_adf )> 4&&_adf [len (_adf )-4:]=="\u006e\u0075\u006c\u006c"{_aag :=_adf [0:len (_adf )-4];_af .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_adf );_af .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_aag );_egeb .skipSpaces ();_ced ,_ :=_egeb ._bge .Peek (1);if _ced [0]=='/'{_ddff .Set (_aag ,_f .MakeNull ());continue ;};};_egeb .skipSpaces ();_afb ,_efbf :=_egeb .parseObject ();if _efbf !=nil {return nil ,_efbf ;};_ddff .Set (_adf ,_afb );_af .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_adf ,_afb .String ());};_af .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");return _ddff ,nil ;};func (_cd *fdfParser )readAtLeast (_dd []byte ,_bdb int )(int ,error ){_fbe :=_bdb ;_bfe :=0;_dcc :=0;for _fbe > 0{_gd ,_eea :=_cd ._bge .Read (_dd [_bfe :]);if _eea !=nil {_af .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_gd ,_dcc ,_eea .Error ());return _bfe ,_a .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_dcc ++;_bfe +=_gd ;_fbe -=_gd ;};return _bfe ,nil ;};func (_ffb *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_ffb ._ba .Seek (0,_db .SeekStart );_ffb ._bge =_e .NewReader (_ffb ._ba );_gbec :=20;_bbeb :=make ([]byte ,_gbec );for {_aab ,_afg :=_ffb ._bge .ReadByte ();if _afg !=nil {if _afg ==_db .EOF {break ;}else {return 0,0,_afg ;};};if _f .IsDecimalDigit (_aab )&&_bbeb [_gbec -1]=='.'&&_f .IsDecimalDigit (_bbeb [_gbec -2])&&_bbeb [_gbec -3]=='-'&&_bbeb [_gbec -4]=='F'&&_bbeb [_gbec -5]=='D'&&_bbeb [_gbec -6]=='P'{_gfa :=int (_bbeb [_gbec -2]-'0');_fgce :=int (_aab -'0');return _gfa ,_fgce ,nil ;};_bbeb =append (_bbeb [1:_gbec ],_aab );};return 0,0,_a .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};var _acd =_b .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");var _efd =_b .MustCompile ("\u0025\u0025\u0045O\u0046");var _cf =_b .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_f .PdfObject ,error ){_fd ,_ed :=fdf .FieldDictionaries ();if _ed !=nil {return nil ,_ed ;};var _cb []string ;for _fb :=range _fd {_cb =append (_cb ,_fb );};_abc .Strings (_cb );_fca :=map[string ]_f .PdfObject {};for _ ,_ggf :=range _cb {_aed :=_fd [_ggf ];_gbe :=_f .TraceToDirectObject (_aed .Get ("\u0056"));_fca [_ggf ]=_gbe ;};return _fca ,nil ;};

// Data represents forms data format (FDF) file data.
type Data struct{_g *_f .PdfObjectDictionary ;_ae *_f .PdfObjectArray ;};func (_efa *fdfParser )parseNull ()(_f .PdfObjectNull ,error ){_ ,_ccb :=_efa ._bge .Discard (4);return _f .PdfObjectNull {},_ccb ;};func (_bbb *fdfParser )setFileOffset (_cbg int64 ){_bbb ._ba .Seek (_cbg ,_db .SeekStart );_bbb ._bge =_e .NewReader (_bbb ._ba );};func (_dbe *fdfParser )parseString ()(*_f .PdfObjectString ,error ){_dbe ._bge .ReadByte ();var _acdd _bb .Buffer ;_dga :=1;for {_debe ,_gda :=_dbe ._bge .Peek (1);if _gda !=nil {return _f .MakeString (_acdd .String ()),_gda ;};if _debe [0]=='\\'{_dbe ._bge .ReadByte ();_edc ,_aa :=_dbe ._bge .ReadByte ();if _aa !=nil {return _f .MakeString (_acdd .String ()),_aa ;};if _f .IsOctalDigit (_edc ){_aga ,_ec :=_dbe ._bge .Peek (2);if _ec !=nil {return _f .MakeString (_acdd .String ()),_ec ;};var _dcg []byte ;_dcg =append (_dcg ,_edc );for _ ,_bga :=range _aga {if _f .IsOctalDigit (_bga ){_dcg =append (_dcg ,_bga );}else {break ;};};_dbe ._bge .Discard (len (_dcg )-1);_af .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_dcg );_ggec ,_ec :=_ab .ParseUint (string (_dcg ),8,32);if _ec !=nil {return _f .MakeString (_acdd .String ()),_ec ;};_acdd .WriteByte (byte (_ggec ));continue ;};switch _edc {case 'n':_acdd .WriteRune ('\n');case 'r':_acdd .WriteRune ('\r');case 't':_acdd .WriteRune ('\t');case 'b':_acdd .WriteRune ('\b');case 'f':_acdd .WriteRune ('\f');case '(':_acdd .WriteRune ('(');case ')':_acdd .WriteRune (')');case '\\':_acdd .WriteRune ('\\');};continue ;}else if _debe [0]=='('{_dga ++;}else if _debe [0]==')'{_dga --;if _dga ==0{_dbe ._bge .ReadByte ();break ;};};_eec ,_ :=_dbe ._bge .ReadByte ();_acdd .WriteByte (_eec );};return _f .MakeString (_acdd .String ()),nil ;};

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_de ,_fe :=_bd .Open (fdfPath );if _fe !=nil {return nil ,_fe ;};defer _de .Close ();return Load (_de );};func (_gcc *fdfParser )parseArray ()(*_f .PdfObjectArray ,error ){_ggc :=_f .MakeArray ();_gcc ._bge .ReadByte ();for {_gcc .skipSpaces ();_dcf ,_ecb :=_gcc ._bge .Peek (1);if _ecb !=nil {return _ggc ,_ecb ;};if _dcf [0]==']'{_gcc ._bge .ReadByte ();break ;};_bc ,_ecb :=_gcc .parseObject ();if _ecb !=nil {return _ggc ,_ecb ;};_ggc .Append (_bc );};return _ggc ,nil ;};func (_deb *fdfParser )readComment ()(string ,error ){var _ce _bb .Buffer ;_ ,_gc :=_deb .skipSpaces ();if _gc !=nil {return _ce .String (),_gc ;};_bdc :=true ;for {_acg ,_ega :=_deb ._bge .Peek (1);if _ega !=nil {_af .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_ega .Error ());return _ce .String (),_ega ;};if _bdc &&_acg [0]!='%'{return _ce .String (),_a .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");};_bdc =false ;if (_acg [0]!='\r')&&(_acg [0]!='\n'){_bgb ,_ :=_deb ._bge .ReadByte ();_ce .WriteByte (_bgb );}else {break ;};};return _ce .String (),nil ;};func (_dbd *fdfParser )readTextLine ()(string ,error ){var _fgc _bb .Buffer ;for {_daa ,_ceg :=_dbd ._bge .Peek (1);if _ceg !=nil {_af .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_ceg .Error ());return _fgc .String (),_ceg ;};if (_daa [0]!='\r')&&(_daa [0]!='\n'){_cegc ,_ :=_dbd ._bge .ReadByte ();_fgc .WriteByte (_cegc );}else {break ;};};return _fgc .String (),nil ;};type fdfParser struct{_acf int ;_eeb int ;_dba map[int64 ]_f .PdfObject ;_ba _db .ReadSeeker ;_bge *_e .Reader ;_ca int64 ;_dg *_f .PdfObjectDictionary ;};func (_fce *fdfParser )parseIndirectObject ()(_f .PdfObject ,error ){_fed :=_f .PdfIndirectObject {};_af .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");_ffd ,_cfbe :=_fce ._bge .Peek (20);if _cfbe !=nil {_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");return &_fed ,_cfbe ;};_af .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_ffd ));_egg :=_abb .FindStringSubmatchIndex (string (_ffd ));if len (_egg )< 6{_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_ffd ));return &_fed ,_a .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_fce ._bge .Discard (_egg [0]);_af .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_egg );_agae :=_egg [1]-_egg [0];_bab :=make ([]byte ,_agae );_ ,_cfbe =_fce .readAtLeast (_bab ,_agae );if _cfbe !=nil {_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_cfbe );return nil ,_cfbe ;};_af .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_bab );_eacg :=_abb .FindStringSubmatch (string (_bab ));if len (_eacg )< 3{_af .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_bab ));return &_fed ,_a .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_gdg ,_ :=_ab .Atoi (_eacg [1]);_bgbb ,_ :=_ab .Atoi (_eacg [2]);_fed .ObjectNumber =int64 (_gdg );_fed .GenerationNumber =int64 (_bgbb );for {_gab ,_eefg :=_fce ._bge .Peek (2);if _eefg !=nil {return &_fed ,_eefg ;};_af .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_gab ),string (_gab ));if _f .IsWhiteSpace (_gab [0]){_fce .skipSpaces ();}else if _gab [0]=='%'{_fce .skipComments ();}else if (_gab [0]=='<')&&(_gab [1]=='<'){_af .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_fed .PdfObject ,_eefg =_fce .parseDict ();_af .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_eefg );if _eefg !=nil {return &_fed ,_eefg ;};_af .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");}else if (_gab [0]=='/')||(_gab [0]=='(')||(_gab [0]=='[')||(_gab [0]=='<'){_fed .PdfObject ,_eefg =_fce .parseObject ();if _eefg !=nil {return &_fed ,_eefg ;};_af .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");}else {if _gab [0]=='e'{_gba ,_cgf :=_fce .readTextLine ();if _cgf !=nil {return nil ,_cgf ;};if len (_gba )>=6&&_gba [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _gab [0]=='s'{_gab ,_ =_fce ._bge .Peek (10);if string (_gab [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_gfd :=6;if len (_gab )> 6{if _f .IsWhiteSpace (_gab [_gfd ])&&_gab [_gfd ]!='\r'&&_gab [_gfd ]!='\n'{_af .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");_gfd ++;};if _gab [_gfd ]=='\r'{_gfd ++;if _gab [_gfd ]=='\n'{_gfd ++;};}else if _gab [_gfd ]=='\n'{_gfd ++;};};_fce ._bge .Discard (_gfd );_bed ,_dab :=_fed .PdfObject .(*_f .PdfObjectDictionary );if !_dab {return nil ,_a .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");};_af .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_bed );_ecfa ,_bcb :=_bed .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_f .PdfObjectInteger );if !_bcb {return nil ,_a .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");};_cdbg :=*_ecfa ;if _cdbg < 0{return nil ,_a .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_cdbg )> _fce ._ca {_af .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");return nil ,_a .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_cfbd :=make ([]byte ,_cdbg );_ ,_eefg =_fce .readAtLeast (_cfbd ,int (_cdbg ));if _eefg !=nil {_af .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_cfbd ),_cfbd );_af .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_eefg );return nil ,_eefg ;};_bdgc :=_f .PdfObjectStream {};_bdgc .Stream =_cfbd ;_bdgc .PdfObjectDictionary =_fed .PdfObject .(*_f .PdfObjectDictionary );_bdgc .ObjectNumber =_fed .ObjectNumber ;_bdgc .GenerationNumber =_fed .GenerationNumber ;_fce .skipSpaces ();_fce ._bge .Discard (9);_fce .skipSpaces ();return &_bdgc ,nil ;};};_fed .PdfObject ,_eefg =_fce .parseObject ();return &_fed ,_eefg ;};};_af .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");return &_fed ,nil ;};

// Load loads FDF form data from `r`.
func Load (r _db .ReadSeeker )(*Data ,error ){_gb ,_da :=_ddca (r );if _da !=nil {return nil ,_da ;};_fc ,_da :=_gb .Root ();if _da !=nil {return nil ,_da ;};_gf ,_fg :=_f .GetArray (_fc .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_fg {return nil ,_a .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");};return &Data {_ae :_gf ,_g :_fc },nil ;};func (_edg *fdfParser )parseObject ()(_f .PdfObject ,error ){_af .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");_edg .skipSpaces ();for {_dag ,_ga :=_edg ._bge .Peek (2);if _ga !=nil {return nil ,_ga ;};_af .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_dag ));if _dag [0]=='/'{_ecf ,_ea :=_edg .parseName ();_af .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_ecf );return &_ecf ,_ea ;}else if _dag [0]=='('{_af .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _edg .parseString ();}else if _dag [0]=='['{_af .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");return _edg .parseArray ();}else if (_dag [0]=='<')&&(_dag [1]=='<'){_af .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _edg .parseDict ();}else if _dag [0]=='<'{_af .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");return _edg .parseHexString ();}else if _dag [0]=='%'{_edg .readComment ();_edg .skipSpaces ();}else {_af .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_dag ,_ =_edg ._bge .Peek (15);_cdc :=string (_dag );_af .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_cdc );if (len (_cdc )> 3)&&(_cdc [:4]=="\u006e\u0075\u006c\u006c"){_eef ,_cfb :=_edg .parseNull ();return &_eef ,_cfb ;}else if (len (_cdc )> 4)&&(_cdc [:5]=="\u0066\u0061\u006cs\u0065"){_be ,_bea :=_edg .parseBool ();return &_be ,_bea ;}else if (len (_cdc )> 3)&&(_cdc [:4]=="\u0074\u0072\u0075\u0065"){_cdb ,_cga :=_edg .parseBool ();return &_cdb ,_cga ;};_bef :=_gge .FindStringSubmatch (_cdc );if len (_bef )> 1{_dag ,_ =_edg ._bge .ReadBytes ('R');_af .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_dag [:]));_cdbf ,_cdca :=_dgbg (string (_dag ));return &_cdbf ,_cdca ;};_bdcb :=_acd .FindStringSubmatch (_cdc );if len (_bdcb )> 1{_af .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _edg .parseNumber ();};_bdcb =_cf .FindStringSubmatch (_cdc );if len (_bdcb )> 1{_af .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");_af .Log .Trace ("\u0025\u0020\u0073",_bdcb );return _edg .parseNumber ();};_af .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_cdc );return nil ,_a .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");};};};